var $iA2ta$reactjsxruntime = require("react/jsx-runtime");
var $iA2ta$react = require("react");

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}

$parcel$export(module.exports, "createAPIs", () => $9233cea927cb9637$export$1f41eb08414e9201);
$parcel$export(module.exports, "Cache", () => $20660adb77b18d0d$export$94affb487e701bf2);


const $9ba0f9a5c47c04f2$export$71594e8a50f746f4 = !!(typeof window !== "undefined" && window.document && window.document.createElement);
const $9ba0f9a5c47c04f2$var$isObj = (obj)=>typeof obj === "object" && obj !== null && !Array.isArray(obj);
function $9ba0f9a5c47c04f2$export$6969335ea1e4e77c(obj1, obj2) {
    if (!$9ba0f9a5c47c04f2$var$isObj(obj1) || !$9ba0f9a5c47c04f2$var$isObj(obj2)) return obj2;
    const obj = {
        ...obj1
    };
    for (const [key, value] of Object.entries(obj2))obj[key] = $9ba0f9a5c47c04f2$export$6969335ea1e4e77c(obj[key], value);
    return obj;
}
function $9ba0f9a5c47c04f2$export$9cb4719e2e525b7a(obj1, obj2) {
    if (typeof obj1 !== typeof obj2) return false;
    if ($9ba0f9a5c47c04f2$var$isObj(obj1) && $9ba0f9a5c47c04f2$var$isObj(obj2)) {
        if (Object.keys(obj1).length !== Object.keys(obj2).length) return false;
        for (const [key, value] of Object.entries(obj1)){
            if (key in obj2) {
                const result = $9ba0f9a5c47c04f2$export$9cb4719e2e525b7a(value, obj2[key]);
                if (!result) return false;
            } else return false;
        }
        return true;
    } else if (Array.isArray(obj1) && Array.isArray(obj2)) {
        if (obj1.length !== obj2.length) return false;
        obj1.forEach((v, i)=>{
            const result = $9ba0f9a5c47c04f2$export$9cb4719e2e525b7a(v, obj2[i]);
            if (!result) return false;
        });
        return true;
    } else return obj1 === obj2;
}
function $9ba0f9a5c47c04f2$export$14186fb9f0d25e90(fn) {
    const subscriptions = {};
    return (...args)=>new Promise(async (resolve, reject)=>{
            const key = JSON.stringify(args);
            subscriptions[key] ||= [];
            const isEmpty = subscriptions[key].length === 0;
            subscriptions[key].push({
                reject: reject,
                resolve: resolve
            });
            if (isEmpty) try {
                const data = await fn(...args);
                while(subscriptions[key].length > 0){
                    const s = subscriptions[key].pop();
                    s?.resolve(data);
                }
            } catch (error) {
                while(subscriptions[key].length > 0){
                    const s = subscriptions[key].pop();
                    s?.reject(error);
                }
            }
        });
}




function $d744cbdd66c30286$export$7f91d7c788ac8416(value) {
    const ref = (0, $iA2ta$react.useRef)(value);
    if (ref.current !== value) ref.current = value;
    return ref;
}
function $d744cbdd66c30286$export$82dbc8d86d695527(value) {
    const ref = (0, $iA2ta$react.useRef)(value);
    return (0, $iA2ta$react.useMemo)(()=>{
        if (!(0, $9ba0f9a5c47c04f2$export$9cb4719e2e525b7a)(ref.current, value)) ref.current = value;
        return ref.current;
    }, [
        value
    ]);
}
const $d744cbdd66c30286$var$rerenderReducer = (s)=>s + 1;
function $d744cbdd66c30286$export$14b855fd280765df() {
    const [, rerender] = (0, $iA2ta$react.useReducer)($d744cbdd66c30286$var$rerenderReducer, 0);
    return rerender;
}
const $d744cbdd66c30286$export$3d6b8a8c752b0789 = (0, $9ba0f9a5c47c04f2$export$71594e8a50f746f4) ? (0, $iA2ta$react.useLayoutEffect) : (0, $iA2ta$react.useEffect);
function $d744cbdd66c30286$export$a76627dcec102ca0(key, cache) {
    const rerender = $d744cbdd66c30286$export$14b855fd280765df();
    $d744cbdd66c30286$export$3d6b8a8c752b0789(()=>{
        cache.subscribe(key, rerender);
        return ()=>cache.unsubscribe(key, rerender);
    }, [
        key
    ]);
    return cache.get(key);
}



const $20660adb77b18d0d$export$86e374d26a6b6e93 = {
    loading: false,
    data: undefined,
    error: undefined
};
class $20660adb77b18d0d$export$94affb487e701bf2 {
    data = {};
    subscriptions = {};
    get = (key)=>{
        return this.data[key] || $20660adb77b18d0d$export$86e374d26a6b6e93;
    };
    set = (key, value)=>{
        if ((0, $9ba0f9a5c47c04f2$export$9cb4719e2e525b7a)(this.data[key], value)) return;
        this.data[key] = value;
        this.subscriptions[key]?.forEach((callback)=>callback());
    };
    subscribe = (key, callback)=>{
        this.subscriptions[key] ||= [];
        if (this.subscriptions[key].indexOf(callback) > -1) return;
        this.subscriptions[key].push(callback);
    };
    unsubscribe = (key, callback)=>{
        this.subscriptions[key] ||= [];
        const idx = this.subscriptions[key].indexOf(callback);
        if (idx > -1) this.subscriptions[key].splice(idx, 1);
    };
}
function $20660adb77b18d0d$export$a4f9b7f788f9e71f(key, variables) {
    return JSON.stringify([
        key,
        variables || {}
    ]);
}
function $20660adb77b18d0d$export$b597e3996a47d45a(key, cache) {
    const { data: data , error: error  } = cache.get(key);
    return !(data === undefined && error === undefined);
}



function $9233cea927cb9637$var$createProvider(ctx) {
    return function Provider({ config: config , children: children , cache: cache = new (0, $20660adb77b18d0d$export$94affb487e701bf2)()  }) {
        const { fetcher: fetcher  } = config;
        const concurrentFetcher = (0, $iA2ta$react.useMemo)(()=>(0, $9ba0f9a5c47c04f2$export$14186fb9f0d25e90)(fetcher), [
            fetcher
        ]);
        return /*#__PURE__*/ (0, $iA2ta$reactjsxruntime.jsx)(ctx.Provider, {
            value: {
                cache: cache,
                config: {
                    ...config,
                    fetcher: concurrentFetcher
                }
            },
            children: children
        });
    };
}
function $9233cea927cb9637$var$stateReducer(_, action) {
    return action;
}
function $9233cea927cb9637$var$partialStateReducer(s, action) {
    return {
        ...s,
        ...action
    };
}
function $9233cea927cb9637$var$createUseLazyApi(ctx, apis) {
    return function useLazyApi(key, defaultOpts = {}) {
        const defaultOptsRef = (0, $d744cbdd66c30286$export$7f91d7c788ac8416)(defaultOpts);
        const { cache: cache , config: { fetcher: fetcher  }  } = (0, $iA2ta$react.useContext)(ctx);
        const [variables, setVariables] = (0, $iA2ta$react.useReducer)($9233cea927cb9637$var$stateReducer, defaultOpts.variables || {});
        const variablesRef = (0, $d744cbdd66c30286$export$7f91d7c788ac8416)(variables);
        const cacheKey = (0, $iA2ta$react.useMemo)(()=>(0, $20660adb77b18d0d$export$a4f9b7f788f9e71f)(key, variables), [
            key,
            variables
        ]);
        const cachedResult = (0, $d744cbdd66c30286$export$a76627dcec102ca0)(cacheKey, cache);
        const [localResult, setLocalResult] = (0, $iA2ta$react.useReducer)($9233cea927cb9637$var$partialStateReducer, (0, $20660adb77b18d0d$export$86e374d26a6b6e93));
        const prevResultRef = (0, $iA2ta$react.useRef)({});
        const cachedRef = (0, $iA2ta$react.useRef)(defaultOpts.cached ?? true);
        const fetch = (0, $iA2ta$react.useCallback)(async (opts = {})=>{
            const api = apis[key];
            const { onFetch: onFetch , onCompleted: onCompleted , cached: cached = true , variables: variables = {}  } = (0, $9ba0f9a5c47c04f2$export$6969335ea1e4e77c)(defaultOptsRef.current, opts);
            const cacheKey = (0, $20660adb77b18d0d$export$a4f9b7f788f9e71f)(key, variables);
            const cacheData = cache.get(cacheKey);
            if (onFetch) await onFetch();
            cachedRef.current = cached;
            if (cached) cache.set(cacheKey, {
                ...cacheData,
                loading: true
            });
            else setLocalResult({
                loading: true
            });
            // if cached is true, we need to set new variables so that `useCachedData` can load data from the new key
            if (cached && !(0, $9ba0f9a5c47c04f2$export$9cb4719e2e525b7a)(variables, variablesRef.current)) setVariables(variables);
            let data = null, error = null;
            try {
                data = await fetcher(api, variables);
            } catch (err) {
                error = err;
            }
            if (onCompleted) await onCompleted({
                data: data,
                error: error
            });
            prevResultRef.current = {
                data: data,
                error: error
            };
            if (cached) cache.set(cacheKey, {
                loading: false,
                data: data,
                error: error
            });
            else setLocalResult({
                loading: false,
                data: data,
                error: error
            });
            return {
                data: data,
                error: error
            };
        }, [
            key,
            cache,
            fetcher,
            setVariables,
            setLocalResult
        ]);
        return [
            fetch,
            {
                ...cachedRef.current ? {
                    ...cachedResult,
                    // when we changed variables, the cached result might be empty, but we want to keep showing the previous result
                    ...!(0, $20660adb77b18d0d$export$b597e3996a47d45a)(cacheKey, cache) && prevResultRef.current
                } : localResult,
                refetch: fetch
            }
        ];
    };
}
function $9233cea927cb9637$var$createUseMutationApi(ctx, apis) {
    const useLazyApi = $9233cea927cb9637$var$createUseLazyApi(ctx, apis);
    return function useMutationApi(key, opts = {}) {
        return useLazyApi(key, {
            ...opts,
            cached: false
        });
    };
}
function $9233cea927cb9637$var$createUseApi(ctx, apis) {
    const useLazyApi = $9233cea927cb9637$var$createUseLazyApi(ctx, apis);
    return function useApi(key, opts = {}) {
        const { cache: cache  } = (0, $iA2ta$react.useContext)(ctx);
        const { skip: skip = false , force: force = false , ...lazyOpts } = opts;
        const latestVariables = (0, $d744cbdd66c30286$export$82dbc8d86d695527)(opts.variables);
        const cacheKey = (0, $iA2ta$react.useMemo)(()=>(0, $20660adb77b18d0d$export$a4f9b7f788f9e71f)(key, latestVariables), [
            key,
            latestVariables
        ]);
        const cached = (0, $iA2ta$react.useMemo)(()=>(0, $20660adb77b18d0d$export$b597e3996a47d45a)(cacheKey, cache), [
            cacheKey,
            cache
        ]);
        const calledRef = (0, $iA2ta$react.useRef)(!skip || cached);
        const loadingRef = (0, $iA2ta$react.useRef)(!skip && !cached);
        const onFetch = (0, $iA2ta$react.useCallback)(async ()=>{
            calledRef.current = true;
            loadingRef.current = true;
        }, []);
        const onCompleted = (0, $iA2ta$react.useCallback)(async ()=>{
            loadingRef.current = false;
        }, []);
        const [fetch, result] = useLazyApi(key, {
            ...lazyOpts,
            onFetch: onFetch,
            onCompleted: onCompleted
        });
        (0, $iA2ta$react.useEffect)(()=>{
            if (skip) return;
            if (!force && (0, $20660adb77b18d0d$export$b597e3996a47d45a)(cacheKey, cache)) return;
            fetch();
        }, [
            skip,
            force,
            fetch,
            key,
            cacheKey,
            cache
        ]);
        return {
            ...result,
            loading: loadingRef.current,
            called: calledRef.current
        };
    };
}
const $9233cea927cb9637$var$missingFetcher = async ()=>{
    throw new Error("Missing fetcher!");
};
function $9233cea927cb9637$export$1f41eb08414e9201(apis) {
    const ctx = /*#__PURE__*/ (0, $iA2ta$react.createContext)({
        cache: new (0, $20660adb77b18d0d$export$94affb487e701bf2)(),
        config: {
            fetcher: $9233cea927cb9637$var$missingFetcher
        }
    });
    return {
        Provider: $9233cea927cb9637$var$createProvider(ctx),
        useLazyApi: $9233cea927cb9637$var$createUseLazyApi(ctx, apis),
        useMutationApi: $9233cea927cb9637$var$createUseMutationApi(ctx, apis),
        useApi: $9233cea927cb9637$var$createUseApi(ctx, apis)
    };
}


//# sourceMappingURL=main.js.map
